
;;DATA ROM TABLES FOR COST REDUCED SM1200
;;FILE: TABLES.ASM
;;
;;COPYRIGHT 1984 HAYES MICROCOMPUTER PRODUCTS INC.
;;
;;WRITTEN BY DALE A. HEATHERINGTON,  MAY 1984.
;;
;;THE DATA IN THIS FILE IS TO BE PROGRAMMED INTO THE
;; LOW HALF OF THE 8K ROM (ADDRESS 0 TO FFF).
;;THE PROGRAM CODE IN THE OTHER FILE (MODEM130)
;;  GOES INTO THE UPPER HALF AT ADDRESS 1000 TO 1FFF.
;;
;;N DEPENDS ON THE LENGTH OF THE SINE TABLE
;; N=1 FOR LENGTH 32
;; N=2 FOR 64
;; N=4 FOR 128
;; N=8 FOR 256 
;;
        N:      EQU     8
;;
        F697:   EQU     595*N
        F770:   EQU     657*N
        F852:   EQU     727*N
        F941:   EQU     803*N
        F1209:  EQU     1032*N
        F1336:  EQU     1140*N
        F1477:  EQU     1260*N
        F1633:  EQU     1393*N
;;
        CR:     EQU     0DH
;;
        RRF:    EQU     1
        PE:     EQU     4
        EPE:    EQU     8
        DBITS:  EQU     10H
        IBF:    EQU     20H
        OVL:    EQU     40H
        DB8:    EQU     80H
;;
        DPLX:   EQU     8
;;
        ORG     1000H
;;
;;DTMF DIGIT TO FREQUENCY PAIR CODE TABLE
;;
TONETBL:DB      'A'
        DB      0E0H            ;;1633,697
        DB      'B'
        DB      0E2H            ;;1633,770
        DB      'C'
        DB      0E4H            ;;1633,852
        DB      'D'
        DB      0E6H            ;;1633,941
        DB      '#'
        DB      0C6H            ;;1477,941
        DB      '*'
        DB      086H            ;;1209,941
        DB      '0'
        DB      0A6H            ;;1336,941
        DB      '9'
        DB      0C4H            ;;1477,852
        DB      '8'
        DB      0A4H            ;;1336,852
        DB      '7'
        DB      084H            ;;1209,852
        DB      '6'
        DB      0C2H            ;;1477,770
        DB      '5'
        DB      0A2H            ;;1336,770
        DB      '4'
        DB      082H            ;;1209,770
        DB      '3'
        DB      0C0H            ;;1477,697
        DB      '2'
        DB      0A0H            ;;1336,697
        DB      '1'
        DB      080H            ;;1209,697
;;
;;DTMF FREQUENCY LOOK-UP TABLE
;;
FRQTBL:
        DW      F697            ;;0 INDEX
        DW      F770            ;;2
        DW      F852            ;;4
        DW      F941            ;;6
        DW      F1209           ;;8
        DW      F1336           ;;A
        DW      F1477           ;;C
        DW      F1633           ;;E
;;
;;THIS TABLE IS USED BY THE PARITY ROUTINE THE SET
;;PROPER STATUS BITS IN "USTAT"
;;
FORMAT: DB      DBITS           ;;8 DATA, NO PARITY
        DB      EPE+PE          ;;7 DATA, EVEN PARITY
        DB      0               ;;7 DATA, PARITY STUCK AT 0
        DB      DB8+DBITS       ;;8 DATA, NO PARITY
        DB      DBITS+EPE+PE    ;;8 DATA, EVEN PARITY
        DB      DBITS+EPE+PE
        DB      DBITS+EPE+PE
        DB      DBITS+EPE+PE+DB8
        DB      DBITS+PE        ;;8 DATA, ODD PARITY
        DB      DB8+DBITS+PE
        DB      DB8+DBITS+PE
        DB      DB8+DBITS+PE
        DB      DBITS           ;; 8 DATA, NO PARITY
        DB      EPE+PE          ;; 7 DATA, EVEN PARITY
        DB      PE              ;; 7 DATA, ODD PARITY
        DB      DB8             ;; 7 DATA, 8TH BIT MARK
;;
P10TAB:
        DB      100
        DB      10
;;THE LAST ENTRY IS THE FIRST ENTRY IN THE NEXT TABLE!
;;
;;THIS DATA GOES INTO THE "S" REGISTERS AT COLD START
;;
INITDATA:
        DB      1               ;;RING TO ANSWER ON
        DB      0               ;;RINGS
        DB      '+'             ;;ESCAPE CHARACTER
        DB      0DH             ;;<CR>
        DB      0AH             ;;<LF>
        DB      8               ;;BACK SPACE
        DB      2               ;;DIAL TONE WAIT TIME
        DB      30              ;;CARRIER DETECT WAIT TIME
        DB      2               ;;COMMA PAUSE TIME
        DB      6               ;;CARRIER DETECT RESP. TIME (X100 MS)
        DB      7               ;;LOST CARRIER TO HANG UP DELAY (X100 MS)
        DB      70              ;;DTMF DURATION
        DB      50              ;;ESCAPE CODE GUARD TIME
        DB      DBITS           ;;USTAT
        DB      0               ;;OFLAGS
        DB      DPLX            ;;PFLAGS
        DB      0               ;;LOOP BACK CONTROL
;;      
;;--------------------------------------------------------
        ORG 1100H
;;256 BYTE SINE LOOKUP TABLE  (FULL POWER )
;;
SINE256:
        DB       128 , 131 , 134 , 137 , 141 , 144 , 147 , 150 
        DB       153 , 156 , 159 , 162 , 165 , 168 , 171 , 174 
        DB       177 , 180 , 183 , 186 , 188 , 191 , 193 , 195 
        DB       198 , 201 , 203 , 206 , 208 , 211 , 213 , 215 
        DB       218 , 220 , 222 , 224 , 226 , 228 , 230 , 232 
        DB       233 , 235 , 237 , 238 , 240 , 241 , 243 , 244 
        DB       245 , 246 , 248 , 249 , 249 , 250 , 251 , 252 
        DB       253 , 253 , 254 , 254 , 254 , 255 , 255 , 255 
        DB       255 , 255 , 255 , 255 , 254 , 254 , 254 , 253 
        DB       253 , 252 , 251 , 250 , 249 , 249 , 248 , 246 
        DB       245 , 244 , 243 , 241 , 240 , 238 , 237 , 235 
        DB       233 , 232 , 230 , 228 , 226 , 224 , 222 , 220 
        DB       218 , 215 , 213 , 211 , 208 , 206 , 203 , 201 
        DB       198 , 195 , 193 , 191 , 188 , 186 , 183 , 180 
        DB       177 , 174 , 171 , 168 , 165 , 162 , 159 , 156 
        DB       153 , 150 , 147 , 144 , 141 , 137 , 134 , 131 
        DB       128 , 125 , 122 , 119 , 115 , 112 , 109 , 106 
        DB       103 , 100 , 97 , 94 , 91 , 88 , 85 , 82 
        DB       79 , 76 , 73 , 70 , 68 , 65 , 63 , 61 
        DB       58 , 55 , 53 , 50 , 48 , 45 , 43 , 41 
        DB       38 , 36 , 34 , 32 , 30 , 28 , 26 , 24 
        DB       23 , 21 , 19 , 18 , 16 , 15 , 13 , 12 
        DB       11 , 10 , 8 , 7 , 7 , 6 , 5 , 4 
        DB       3 , 3 , 2 , 2 , 2 , 1 , 1 , 1 
        DB       1 , 1 , 1 , 1 , 2 , 2 , 2 , 3 
        DB       3 , 4 , 5 , 6 , 7 , 7 , 8 , 10 
        DB       11 , 12 , 13 , 15 , 16 , 18 , 19 , 21 
        DB       23 , 24 , 26 , 28 , 30 , 32 , 34 , 36 
        DB       38 , 41 , 43 , 45 , 48 , 50 , 53 , 55 
        DB       58 , 61 , 63 , 65 , 68 , 70 , 73 , 76 
        DB       79 , 82 , 85 , 88 , 91 , 94 , 97 , 100 
        DB       103 , 106 , 109 , 112 , 115 , 119 , 122 , 125 
;;
;;256 BYTE SINE TABLE WITH 2DB LOSS
;;
        ORG     1200H
;;
        DB       128 , 130 , 133 , 135 , 138 , 141 , 143 , 145 
        DB       148 , 150 , 153 , 155 , 157 , 160 , 162 , 165 
        DB       167 , 169 , 172 , 174 , 176 , 178 , 180 , 181 
        DB       184 , 186 , 188 , 190 , 192 , 194 , 195 , 197 
        DB       199 , 201 , 203 , 204 , 206 , 207 , 209 , 211 
        DB       211 , 213 , 215 , 215 , 217 , 218 , 219 , 220 
        DB       221 , 222 , 223 , 224 , 224 , 225 , 226 , 226 
        DB       227 , 227 , 228 , 228 , 228 , 229 , 229 , 229 
        DB       229 , 229 , 229 , 229 , 228 , 228 , 228 , 227 
        DB       227 , 226 , 226 , 225 , 224 , 224 , 223 , 222 
        DB       221 , 220 , 219 , 218 , 217 , 215 , 215 , 213 
        DB       211 , 211 , 209 , 207 , 206 , 204 , 203 , 201 
        DB       199 , 197 , 195 , 194 , 192 , 190 , 188 , 186 
        DB       184 , 181 , 180 , 178 , 176 , 174 , 172 , 169 
        DB       167 , 165 , 162 , 160 , 157 , 155 , 153 , 150 
        DB       148 , 145 , 143 , 141 , 138 , 135 , 133 , 130 
        DB       128 , 126 , 123 , 121 , 118 , 115 , 113 , 111 
        DB       108 , 106 , 103 , 101 , 99 , 96 , 94 , 91 
        DB       89 , 87 , 84 , 82 , 80 , 78 , 76 , 75 
        DB       72 , 70 , 68 , 66 , 64 , 62 , 61 , 59 
        DB       57 , 55 , 53 , 52 , 50 , 49 , 47 , 45 
        DB       45 , 43 , 41 , 41 , 39 , 38 , 37 , 36 
        DB       35 , 34 , 33 , 32 , 32 , 31 , 30 , 30 
        DB       29 , 29 , 28 , 28 , 28 , 27 , 27 , 27 
        DB       27 , 27 , 27 , 27 , 28 , 28 , 28 , 29 
        DB       29 , 30 , 30 , 31 , 32 , 32 , 33 , 34 
        DB       35 , 36 , 37 , 38 , 39 , 41 , 41 , 43 
        DB       45 , 45 , 47 , 49 , 50 , 52 , 53 , 55 
        DB       57 , 59 , 61 , 62 , 64 , 66 , 68 , 70 
        DB       72 , 75 , 76 , 78 , 80 , 82 , 84 , 87 
        DB       89 , 91 , 94 , 96 , 99 , 101 , 103 , 106 
        DB       108 , 111 , 113 , 115 , 118 , 121 , 123 , 126 


;;---------------------------------------------------------
        ORG     1300H
;;
;;VERBOSE RESULT CODES AND HELP MESSAGES.
;;BIT 7 HIGH INDICATES BEGINNING OF EACH MESSAGE.
;;
OKMSG:  DB      0CFH,'K'                ;;0
        DB      0C3H,'ONNECT'           ;;1
        DB      0D2H,'ING'              ;;2
        DB      0CEH,'O CARRIER'        ;;3
        DB      0C5H,'RROR'             ;;4
        DB      0C3H,'ONNECT 1200'      ;;5
        DB      0CEH,'O DIALTONE'       ;;6
        DB      0C2H,'USY'              ;;7
        DB      0CEH,'O ANSWER'         ;;8
        DB      0A0H                    ;;9 NOT USED
;;
;;  ? COMMAND
;;
        DB      0A0H
        DB      '   HELP COMMAND DIRECTORY',CR,CR
        DB      'AT?     DIRECTORY',CR
        DB      'AT?1    PRIMARY COMMANDS',CR
        DB      'AT?2    SECONDARY COMMANDS',CR
        DB      'AT?3    ADDITIONAL SECONDARY COMMANDS',CR
        DB      'AT?4    "S" REGISTER FUNCTIONS',CR
        DB      'AT?5    CONFIGURATION SWITCHES',CR
        DB      'AT?6    SELF TEST COMMANDS',CR,CR
        DB      'ALL COMMANDS START WITH "AT" AND',CR
        DB      'END WITH RETURN EXCEPT "A/" AND "+++".'
        
;;
;;  ?1 COMMAND
;;
        DB      0A0H
        DB      '   PRIMARY COMMANDS',CR,CR
        DB      'A/      REPEAT LAST COMMAND',CR
        DB      'A       ANSWER CALL',CR,CR
        DB      'D   0..9*#ABCD  DIALS PHONE NUMBER',CR
        DB      '    T   TONE DIAL',CR
        DB      '    P   PULSE DIAL',CR
        DB      '    W   WAIT FOR SECOND DIAL TONE',CR
        DB      '    ,   PAUSE',CR
        DB      '    ;   TERMINATE DIAL COMMAND',CR
        DB      '    R   REVERSE MODE',CR
        DB      '    !   FLASH',CR
        DB      '    /   WAIT 1/8 SECOND',CR
        DB      '    @   WAIT FOR QUIET ANSWER',CR,CR
        DB      '+++     GO FROM ONLINE TO COMMAND MODE',CR
        DB      'H       DISCONNECT',CR
        DB      'O       GO ONLINE IN CURRENT MODE'
;;
;; ?2 COMMAND
;;
        DB      0A0H                    ;;11
        DB      '   SECONDARY COMMANDS',CR,CR
        DB      'B   0   CCITT V.22 MODE',CR
        DB      '    1   BELL 212A & 103 MODE',CR
        DB      'C   0   TRANSMITT CARRIER OFF',CR
        DB      '    1  *CARRIER ON',CR
        DB      'E   0   CHARACTERS NOT ECHOED',CR
        DB      '    1   CHARACTERS ECHOED',CR
        DB      'F   0   HALF DUPLEX',CR
        DB      '    1  *FULL DUPLEX',CR
        DB      'L   1   LOW SPEAKER VOLUME',CR
        DB      '    2  *MEDIUM SPEAKER VOLUME',CR
        DB      '    3   HIGH SPEAKER VOLUME',CR
        DB      'M   0   SPEAKER ALWAYS OFF',CR
        DB      '    1  *SPEAKER ON UNTIL CARRIER DETECT',CR
        DB      '    2   SPEAKER ALWAYS ON',CR
        DB      '* = DEFAULT VALUE WHEN FIRST TURNED ON'
;;
;;  ?3 COMMAND
;;
        DB      0A0H
        DB      '   ADDITIONAL SECONDARY COMMANDS',CR,CR
        DB      'Q   0   QUIET, NO RESULT CODES',CR
        DB      '    1   RESULT CODES SENT',CR
        DB      'V   0   DIGIT RESULT CODES',CR
        DB      '    1   WORD RESULT CODES',CR
        DB      'X   0  *BASIC FUNCTIONS',CR
        DB      '    1   EXTENDED RESULT CODES',CR
        DB      '    2   DIAL TONE DETECTION ENABLED',CR
        DB      '    3   BUSY SIGNAL DETECTION ENABLED',CR
        DB      '    4   DIAL TONE AND BUSY ENABLED',CR
        DB      'Z       SOFTWARE RESET',CR
        DB      '* = DEFAULT VALUE WHEN FIRST TURNED ON'
;;
;; ?4 COMMAND
;;
        DB      80H                     ;;12
        DB      '   "S" REGISTERS',CR,CR
        DB      'S0   1   RING TO ANSWER ON',CR
        DB      'S1   0   RINGS IF NOT ON-LINE',CR
        DB      '    50   SIGNAL QUALITY IF ON-LINE',CR
        DB      'S2  43   ESCAPE CODE CHARACTER',CR
        DB      'S3  13   CARRIAGE RETURN CHARACTER',CR
        DB      'S4  10   LINE FEED CHARACTER',CR
        DB      'S5   8   BACK SPACE CHARACTER',CR
        DB      'S6   2   SECONDS TO WAIT FOR DIAL TONE',CR
        DB      'S7  30   MAX. TIME TO WAIT FOR CARRIER',CR
        DB      'S8   2   COMMA PAUSE TIME',CR
        DB      'S9   6   CARRIER DETECT RESPONSE TIME',CR
        DB      'S10  7   CARRIER LOSS TO HANG-UP DELAY',CR
        DB      'S11 70   TOUCH-TONE DURATION',CR
        DB      'S12 50   ESCAPE CODE GUARD TIME',CR
        DB      'S13,S14,S15 BIT MAPPED, SEE MANUAL',CR
        DB      'S16  0   SELF TEST MODE CONTROL',CR,CR
        DB      'S  R=N  PUTS VALUE "N" INTO REGISTER "R"',CR
        DB      'S  R?   READS THE VALUE IN REGISTER "R"'
;;
;; ?5 COMMAND
;;
        DB      0A0H                    ;;13
        DB      '         CONFIGURATION SWITCHES',CR,CR
        DB      '1   UP   SUPPORTS RS-232 DTR CONTROL',CR
        DB      '   DOWN *IGNORES DTR',CR
        DB      '2   UP  *WORD RESULT CODES',CR
        DB      '   DOWN  DIGIT RESULT CODES',CR
        DB      '3   UP   QUIET, NO RESULT CODES',CR
        DB      '   DOWN *RESULT CODES SENT',CR
        DB      '4   UP  *COMMAND ECHO ENABLED',CR
        DB      '   DOWN  DISABLED',CR
        DB      '5   UP   AUTO-ANSWER ENABLED',CR
        DB      '   DOWN *AUTO ANSWER DISABLED',CR
        DB      '6   UP   RS-232 CARRIER DETECT NORMAL',CR
        DB      '   DOWN *RS-232 CARRIER DETECT ON ALWAYS',CR
        DB      '7   UP  *SINGLE LINE RJ-11 PHONE JACK',CR
        DB      '   DOWN  MULTI-LINE RJ-13 PHONE JACK',CR
        DB      '8   UP   DISABLE COMMAND RECOGNITION',CR
        DB      '   DOWN *ENABLE COMMANDS',CR
        DB      '9   UP  *BELL 103 AND 212 COMPATABLE',CR
        DB      '   DOWN  CCITT V.22 COMPATABLE',CR
        DB      '10  UP  *RESET WHEN TURNED ON',CR
        DB      '   DOWN  RESET WHEN RS-232 DTR GOES FALSE',CR
        DB      '* = FACTORY SETTING'
        DB      0A0H
;;
;;   ?6 COMMAND
;;
        DB      '    SELF TEST COMMANDS',CR,CR
        DB      '  ROM MEMORY TEST',CR
        DB      '  AT I1    RESULT = ROM CHECKSUM',CR
        DB      '  AT I2    RESULT = "OK" OR "ERROR"',CR
        DB      '  ANALOG LOOP-BACK COMMANDS',CR
        DB      '  AT S16=1 A    ANSWER',CR
        DB      '  AT S16=1 D    ORIGINATE',CR
        DB      '* AT S16=1 O    CURRENT MODE',CR,CR
        DB      '  DIGITAL LOOP-BACK COMMAND',CR
        DB      '* AT S16=4 O',CR,CR
        DB      '  AT S16=0 OR ATZ EXITS TEST MODE',CR,CR
        DB      '  REMOTE DIGITAL LOOP-BACK COMMANDS',CR
        DB      '* AT O2         ON',CR
        DB      '* AT O1         OFF',CR,CR
        DB      ' * MUST HAVE CONNECTION ESTABLISHED FIRST.'
        DB      80H,80H,80H,'7/25/84',CR,80H
        DB      CR
;;
;;
        END
